<?php
/**
 * Do not allow direct access
 *
 * @since    1.0.0
 */
if ( ! defined( 'ABSPATH' ) ) die( 'Don\'t try to load this file directly!' );

/**
 * Divi - Filterable Blog Module - Controller Modules
 *
 * @since    1.0.0
 */
if ( ! class_exists( 'dfbmControllerModules' ) )
{

    class dfbmControllerModules extends DiviExtension
    {

        /**
         * Define properties
         *
         * @since    1.0.0
         */
        public $name;

        public $version;

        public $gettext_domain;

        /**
         * Constructor
         *
         * @since    1.0.0
         */
        public function __construct( $name = 'divi-filterable-blog-module', $args = [] )
        {

            // parent::__construct( $name, $args );

            /**
             * Initialize
             *
             * @since 1.0.0
             */
            $this->initialize();

        } // end constructor

        /**
         * Initialize DFBM Modules
         *
         * @since 1.0.0
         */
        public function initialize()
        {

            $this->name = 'divi-filterable-blog-module';

            $this->plugin_dir_url = DFBM()->assets();

            $this->plugin_dir = DFBM()->includes();

            $this->gettext_domain = $this->name;

            $this->version = DFBM()->version();

            parent::__construct( $this->name );

            $slugs = [ 'blog', 'blog_light' ];

            foreach ( $slugs as $slug ) :

                $this->slugs[] = 'et_pb_' . DFBM()->prefix() . '_' . $slug;

            endforeach;

            DFBM()->setLayout( $this->slugs, 'slugs' );

        } // end initialize

        /**
         * Just to fix the warning
         *
         * @since 1.0.0
         */
        public function modules() { } // end modules

    } // end class
} // end if
