(function($){$(function(){

    class dfbmAdmin
    {

        setProperties( opt )
        {

            this.opt = $.extend( {},
            {

                prefix  : 'et_pb_templates_',
                prfix   : '',
                newVers : '',
                error   : '',
                slugs   : '',

            }, opt );

            this.prfix   = new RegExp( this.opt.prfix );

            this.newVers = parseInt( this.opt.newVers );

        } // end setProperties

        constructor( opt )
        {

            this.setProperties( opt );

            this.initialize();

        } // end constructor

        initialize( self = this )
        {

            let checkStorage = setInterval( function()
            {

                if ( 'string' == typeof localStorage.et_pb_templates_settings_product_version )
                {

                    clearInterval( checkStorage );

                    setTimeout( () =>
                    {

                        if ( self.newVers )
                            self.rebuild( false );

                        else
                            self.check();

                    }, 1000 );
                }
            }, 300 );
        } // end initialize

        check()
        {

            if ( ! this.local() )
                return;

            let item, temp, mods = [];

            for ( item in localStorage )
            {

                if ( -1 !== item.indexOf( this.prfix ) )
                {

                    mods.push( item );

                }
            }

            if ( mods.length != this.opt.slugs.length )
                this.rebuild( true, mods );

        } // end check

        local()
        {

            return 'localStorage' in window && window.localStorage !== null;

        }

        rebuild( clear, mods = false, self = this )
        {

            let get, pref = 'et_pb_templates_';

            if ( ! clear )
                this.clear();

            if ( mods )
                get = this.opt.slugs.filter( item =>
                {

                    return mods.indexOf( pref + item ) < 0

                });

            else
                get = this.opt.slugs;

            $.ajax(
            {

                type     : 'post',
                dataType : 'json',
                url      : et_pb_options.ajaxurl,
                data:
                {

                    action              : 'et_pb_get_backbone_template',
                    et_post_type        : et_pb_options.post_type,
                    et_admin_load_nonce : et_pb_options.et_admin_load_nonce,
                    et_modules_slugs    : JSON.stringify({ missing_modules_array: get }),

                },
                success: function( data )
                {

                    if ( 'undefined' != typeof data.templates && data.templates.length > 0 )
                    {

                        $.each( data.templates, ( i, item ) =>
                        {

                            let template = self.template( item['template'], data.unique );

                            if ( self.local() )
                            {

                                try
                                {

                                    localStorage.setItem( pref + item['slug'], LZString.compressToUTF16( template ) );

                                    console.log( 'DFBM Cache rebuilt.' );

                                }

                                catch(e)
                                {

                                    console.log( 'An error occurred while the DFBM cache was being rebuilt.' );

                                }
                            }

                            $( '#et-builder-' + item['slug'] + '-module-template' ).remove();

                            $( 'body' ).append( template );

                        });
                    } // end if
                },

                error: function( r )
                {

                    console.log( r );

                }
            });
        } // end rebuild

        template( template, map )
        {

            if ( 'undefined' == typeof map )
                return template;

            let str = /<!-- (\d+) -->/g;

            return template.replace( str, ( match, key ) =>
            {

                return map[key];

            } );
        } // end template

        clear()
        {

            for ( let item in localStorage )
            {

                if ( -1 !== item.indexOf( this.prfix ) )
                    localStorage.removeItem( item );

            }
        } // end clear

        error()
        {

            this.clear();

            alert( this.opt.error );

        } // end error

        local()
        {

            return 'localStorage' in window && window.localStorage !== null;

        } // end local
    } // end dfbmAdmin

    new dfbmAdmin(
    {

        prfix   : dfbmPHP.prfix,
        newVers : dfbmPHP.new,
        error   : dfbmPHP.error,
        slugs   : dfbmPHP.slugs,

    });

});}(jQuery));
