// Hadley Child Theme for Divi by Brand & Build
// Post carousels
jQuery(document).ready(function ($) {
    // Post carousel
    if ($('.bb-hadley-post-carousel .et_pb_ajax_pagination_container').length) {
        $('.bb-hadley-post-carousel .et_pb_ajax_pagination_container').flickity({
            // options
            cellAlign: 'center', //Align slides to center
            contain: true, //Prevents carousel overlap (no effect with wraparound)
            cellSelector: '.et_pb_post', //Item selector
            groupCells: 1, //Posts to scroll - increase value to scroll more than 1 post at a time
            wrapAround: true, //Infinite slides
            draggable: true, //Slides to drag - use numberical value or set to false for none
            selectedAttraction: 0.01, //Attracts the position of the slider to the selected cell
            friction: 0.15, //Controls the movement of slider
            freeScroll: false, //Stick to center slide?
            freeScrollFriction: 0.075, // Lower friction, slides easier
            prevNextButtons: true, //Show buttons
            pageDots: false, //Show dots
            autoPlay: 4000, //Autoplay speed in milliseconds. Default 3000ms Set to false to stop autoplay.
            pauseAutoPlayOnHover: true, // Pause on hover?
            adaptiveHeight: false, //Carousel will adjust its height per slide
            imagesLoaded: true,
        });
    }
    // Center post carousel
    if ($('.bb-hadley-post-carousel-center .et_pb_ajax_pagination_container').length) {
        $('.bb-hadley-post-carousel-center .et_pb_ajax_pagination_container').flickity({
            // options
            cellAlign: 'center', //Align slides to center
            contain: true, //Prevents carousel overlap (no effect with wraparound)
            cellSelector: '.et_pb_post', //Item selector
            groupCells: 1, //Posts to scroll - increase value to scroll more than 1 post at a time
            wrapAround: true, //Infinite slides
            draggable: true, //Slides to drag - use numerical value or set to false
            freeScroll: false, //Stick to center slide?
            freeScrollFriction: 0.075, // Lower friction, slides easier
            prevNextButtons: true, //Show buttons
            pageDots: false, //Show dots
            autoPlay: 4000, //Autoplay speed in milliseconds. Default 3000ms Set to false to stop autoplay.
            pauseAutoPlayOnHover: true, // Pause on hover?
            adaptiveHeight: false, //Carousel will adjust its height per slide
            imagesLoaded: true,

        });
    }
    //Post content carousel
    if ($('.bb-hadley-post-content-carousel .et_pb_ajax_pagination_container').length) {
        $('.bb-hadley-post-content-carousel .et_pb_ajax_pagination_container').flickity({
            // options
            cellAlign: 'left', //Align slides to center
            contain: true, //Prevents carousel overlap (no effect with wraparound)
            cellSelector: '.et_pb_post', //Item selector
            groupCells: true, //Posts to scroll - will scroll all cells in viewport
            wrapAround: true, //Infinite slides
            draggable: true, //Slides to drag - use numberical value or set to false for none
            selectedAttraction: 0.01, //Attracts the position of the slider to the selected cell
            friction: 0.15, //Controls the movement of slider
            freeScroll: true, //Stick to center slide?
            freeScrollFriction: 0.075, // Lower friction, slides easier
            prevNextButtons: true, //Show buttons
            pageDots: false, //Show dots
            autoPlay: 4000, //Autoplay speed in milliseconds. Default 3000ms Set to false to stop autoplay.
            pauseAutoPlayOnHover: true, // Pause on hover?
            adaptiveHeight: false, //Carousel will adjust its height per slide
            imagesLoaded: true,
        });
    }
});

// Post modules

(function ($) {
    $(document).on('ready ajaxComplete', function () {
        //Remove pipes, commas and 'by' from the meta
        $(
            '.bb-hadley-blog .et_pb_post .post-meta, .bb-hadley-post-slider .et_pb_slide .post-meta, .bb-hadley-post-title .et_pb_title_meta_container'
        ).html(function () {
            return $(this)
                .html()
                .replace(/\|/g, '')
                .replace('by', '')
                .replace(/,/g, '');
        });
        // Wrap the post content in a container
        $('.bb-hadley-blog .et_pb_post').each(function () {
            $(this)
                .find('> .entry-title, > .post-meta, > .post-content')
                .wrapAll('<div class="bb-hadley-post-content"></div>');
        });
        // Wrap the categories in a container
        $(
            '.bb-hadley-blog .et_pb_post .bb-hadley-post-content .post-meta'
        ).each(function () {
            $(this)
                .find('a[rel~="tag"]')
                .wrapAll('<div class="bb-hadley-post-cats"></div>');
        });
        // Move categories above title
        $('.bb-hadley-blog .et_pb_post .post-meta').each(function () {
            $(this).find('> .bb-hadley-post-cats').prependTo($(this).parent());
        });
        // Read more on video posts
        $(
            '.bb-hadley-blog .et_pb_post.post_format-post-format-video a.more-link'
        ).html(function () {
            return $(this).html().replace('read more', 'Watch Now');
        });
        //Wrap text nodes in comments container and remove all but last
        $('.bb-hadley-blog .post-meta, .bb-hadley-post-slider .post-meta')
            .contents()
            .filter(function () {
                return this.nodeType === 3;
            })
            .wrap('<span class="bb-hadley-blog-comments"></span>')
            .end();
        $(
            '.bb-hadley-blog .post-meta span.bb-hadley-blog-comments:not(:last-child), .bb-hadley-post-slider .post-meta span.bb-hadley-blog-comments:not(:last-child)'
        ).remove();
        //If comments are switched off, remove the container
        $('span.bb-hadley-blog-comments').each(function () {
            if (!$(this).text().trim().length) {
                $(this).remove();
            }
        });
    });
})(jQuery);


// Post slider
(function ($) {
    $(document).on('ready ajaxComplete', function () {
        // Wrap the categories in a container
        $('.bb-hadley-post-slider .et_pb_slide').each(function () {
            $(this)
                .find('.et_pb_slide_description .post-meta [rel~="tag"]')
                .wrapAll('<div class="bb-hadley-post-cats"></div>');
        });
        // Move categories above title
        $('.bb-hadley-post-slider .et_pb_slide').each(function () {
            $(this)
                .find('.bb-hadley-post-cats')
                .detach()
                .insertBefore($('.et_pb_slide_title', this));
        });
    });
})(jQuery);


// Collapse mobile menu
(function($) {
    function bb_collapse_mobile() {
        $('.bb-hadley-header-menu .mobile_nav .menu-item-has-children > a').after('<span class="expand"></span>');
        $('.bb-hadley-header-menu .mobile_nav .menu-item-has-children > a').each(function() {
            $(this).next().next('.sub-menu').toggleClass('collapsed',3000);
        });
        $('.bb-hadley-header-menu .mobile_nav .menu-item-has-children > a + span').on('click', function(event) {
            event.preventDefault();
            $(this).toggleClass('collapse');
            $(this).next('.sub-menu').toggleClass('collapsed',3000);
        });
    }
    $(window).load(function() {
        setTimeout(function() {
            bb_collapse_mobile();
        }, 700);
    });
})(jQuery);


// Search results
jQuery(document).ready(function ($) {
    // Remove search term pre text
    $('#bb-hadley-search-term .et_pb_text_inner h1').html(function () {
        return $(this).html().replace('Results for ', '');
    });
});
